SystemOrganization addCategory: #Estanciero!

TestCase subclass: #TestsEstanciero
	instanceVariableNames: 'apo fede agus banco tablero salida formosa zonaSurF zonaCentroF zonaNorteF premioGanadero empresaPetrolera salta zonaSurS zonaCentroS zonaNorteS bodega tucuman zonaSurT zonaNorteT fabrica cordoba zonaSurC zonaCentroC zonaNorteC juego'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!TestsEstanciero methodsFor: 'as yet unclassified' stamp: 'Federico 10/9/2012 15:03'!
setUp 
	
	apo := Participante new.
	apo dinero: 50000.
	
	fede := Participante new.
	fede dinero: 10000.
	
	agus := Participante new.
	banco := Banco new.
	
	tablero := Tablero new.
	tablero banco: banco.
	
	salida := Salida new.
	salida tablero: tablero.
	
	formosa := Provincia new.
	formosa tablero: tablero.
	
	zonaSurF := Campo unCampoEn: formosa conPrecio: 1000 conValorRenta: 500 conUnCostoDeConstruccionDeEstancia: 500.

	zonaCentroF := Campo unCampoEn: formosa conPrecio: 1000 conValorRenta: 500 conUnCostoDeConstruccionDeEstancia: 250.

	zonaNorteF := Campo unCampoEn: formosa conPrecio: 1200 conValorRenta: 600 conUnCostoDeConstruccionDeEstancia: 300.

	premioGanadero := Premio new.
	premioGanadero tablero: tablero.

	empresaPetrolera := EmpresaConRentaFija new.
	empresaPetrolera tablero: tablero.
	empresaPetrolera precio: 380.
	empresaPetrolera rentaFija: 200.
	empresaPetrolera dueo: banco.

	salta := Provincia new.
	salta tablero: tablero.

	zonaSurS := Campo unCampoEn: salta conPrecio: 2600 conValorRenta: 800 conUnCostoDeConstruccionDeEstancia: 300.
	
	zonaCentroS := Campo unCampoEn: salta conPrecio: 2600 conValorRenta: 850 conUnCostoDeConstruccionDeEstancia: 300.

	zonaNorteS := Campo unCampoEn: salta conPrecio: 3000 conValorRenta: 900 conUnCostoDeConstruccionDeEstancia: 350.

	bodega := EmpresaConRentaFija new.
	bodega tablero: tablero.
	bodega precio: 380.
	bodega rentaFija: 150.
	bodega dueo: banco.

	tucuman := Provincia new.
	tucuman tablero: tablero.

	zonaSurT := Campo unCampoEn: tucuman conPrecio: 5000 conValorRenta: 1000 conUnCostoDeConstruccionDeEstancia: 400.

	zonaNorteT := Campo unCampoEn: tucuman conPrecio: 5400 conValorRenta: 1200 conUnCostoDeConstruccionDeEstancia: 500.
	
	fabrica := EmpresaConRentaFija new.
	fabrica tablero: tablero.
	fabrica precio: 380.
	fabrica rentaFija: 150.
	fabrica dueo: banco.

	cordoba := Provincia new.
	cordoba tablero: tablero.

	zonaSurC := Campo unCampoEn: cordoba conPrecio: 6000 conValorRenta: 1500 conUnCostoDeConstruccionDeEstancia: 800.

	zonaCentroC := Campo unCampoEn: cordoba conPrecio: 6000 conValorRenta: 1500 conUnCostoDeConstruccionDeEstancia: 800.

	zonaNorteC:= Campo unCampoEn: cordoba conPrecio: 6400 conValorRenta: 1500 conUnCostoDeConstruccionDeEstancia: 900.

	juego := Juego new.
	juego tablero: tablero.
	juego agregarJugadores: apo.
	juego agregarJugadores: fede.

	apo agregarPropiedades: zonaSurT.
	apo agregarPropiedades: zonaNorteT.
	apo agregarPropiedades: zonaSurF.
	zonaNorteT cantidadEstancias: 1.

	fede agregarPropiedades: zonaSurC.
	fede agregarPropiedades: zonaCentroC.
	fede agregarPropiedades: zonaNorteC.
	fede agregarPropiedades: zonaCentroF.
	fede agregarPropiedades: bodega.
	fede agregarPropiedades: empresaPetrolera.! !

Object subclass: #Casillero
	instanceVariableNames: 'tablero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Casillero methodsFor: 'as yet unclassified' stamp: 'Federico 9/8/2012 10:56'!
cayo: unJugador
	"Si el casillero no entendio antes que hacer no tiene que hacer nada"! !

!Casillero methodsFor: 'as yet unclassified' stamp: 'Federico 9/8/2012 10:56'!
paso: unJugador
	"Si el casillero no entendio antes que hacer no tiene que hacer nada"! !

!Casillero methodsFor: 'getter' stamp: 'Federico 9/3/2012 21:02'!
tablero
	^tablero.! !

!Casillero methodsFor: 'setter' stamp: 'Federico 9/6/2012 22:23'!
tablero: tableroActual
	tablero := tableroActual.
	tableroActual agregarCasilleros: self.! !

Casillero subclass: #Premio
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Premio methodsFor: 'as yet unclassified' stamp: 'Apo 9/6/2012 16:08'!
cayo: jugador
	jugador recibe: 2500.! !

Casillero subclass: #Prision
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

Casillero subclass: #Propiedad
	instanceVariableNames: 'precio dueo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

Propiedad subclass: #Campo
	instanceVariableNames: 'provincia valorRenta costoConstruccionEstancia cantidadEstancias'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Campo class methodsFor: 'as yet unclassified' stamp: 'Federico 10/9/2012 14:55'!
unCampoEn: unaProvincia conPrecio: unPrecio conValorRenta: unaRenta conUnCostoDeConstruccionDeEstancia: unCosto
	| nuevoCampo |
	nuevoCampo := Campo new.
	nuevoCampo provincia: unaProvincia.
	nuevoCampo dueo: unaProvincia tablero banco. "Hace que cada campo tome como dueo al banco del tablero en el que esta su provincia"
	unaProvincia tablero banco agregarPropiedades:  nuevoCampo. "Agrega el campo a las propiedades del banco"
	nuevoCampo tablero: unaProvincia tablero. "Hace que el casillero entienda cual es su tablero"
	nuevoCampo precio: unPrecio.
	nuevoCampo valorRenta: unaRenta.
	nuevoCampo costoConstruccionEstancia: unCosto.
	^nuevoCampo.! !

!Campo methodsFor: 'getter' stamp: 'Federico 9/18/2012 10:35'!
agregarEstanciaDe: jugador
	self provincia verificaConstruccionEn:  self .
	jugador comprarEstanciaEn: self. 
	self cantidadEstancias: self cantidadEstancias + 1. ! !

!Campo methodsFor: 'getter' stamp: 'Apo 9/6/2012 19:02'!
cantidadEstancias
	^cantidadEstancias.! !

!Campo methodsFor: 'setter' stamp: 'Apo 9/6/2012 19:01'!
cantidadEstancias: unaCantEstancias
	cantidadEstancias := unaCantEstancias. ! !

!Campo methodsFor: 'getter' stamp: 'Federico 9/3/2012 23:15'!
costoConstruccionEstancia
	^costoConstruccionEstancia.! !

!Campo methodsFor: 'setter' stamp: 'Federico 9/3/2012 23:15'!
costoConstruccionEstancia: costoActual
	costoConstruccionEstancia := costoActual.! !

!Campo methodsFor: 'as yet unclassified' stamp: 'Federico 9/11/2012 05:25'!
initialize 
	cantidadEstancias := 0.! !

!Campo methodsFor: 'getter' stamp: 'Federico 9/3/2012 21:19'!
provincia
	^provincia.! !

!Campo methodsFor: 'setter' stamp: 'Federico 10/9/2012 15:04'!
provincia: provinciaActual
	provincia := provinciaActual.
	provinciaActual agregarCampos: self. "Le dice a la provincia que tiene un campo nuevo para agregar"! !

!Campo methodsFor: 'as yet unclassified' stamp: 'Apo 9/6/2012 19:44'!
renta: cantEstancias
	^(2 raisedTo:  cantEstancias) * valorRenta.! !

!Campo methodsFor: 'setter' stamp: 'Federico 9/15/2012 20:05'!
rentaPara: jugador
	^self renta: self cantidadEstancias.! !

!Campo methodsFor: 'getter' stamp: 'Federico 9/3/2012 23:14'!
valorRenta
	^valorRenta.! !

!Campo methodsFor: 'setter' stamp: 'Federico 9/3/2012 23:14'!
valorRenta: rentaActual
	valorRenta := rentaActual.! !

Propiedad subclass: #Empresa
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Empresa methodsFor: 'as yet unclassified' stamp: 'Federico 9/6/2012 21:12'!
renta: numeroDado
	^numeroDado * 30000 * self dueo cantidadEmpresas.! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'Federico 10/3/2012 16:06'!
rentaPara: jugador
	^self renta: jugador tirarDados.! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'Federico 9/4/2012 11:18'!
sosEmpresa
	^true.! !

Empresa subclass: #EmpresaConRentaFija
	instanceVariableNames: 'rentaFija'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!EmpresaConRentaFija methodsFor: 'as yet unclassified' stamp: 'Federico 9/15/2012 20:18'!
rentaFija 
	^rentaFija.! !

!EmpresaConRentaFija methodsFor: 'as yet unclassified' stamp: 'Federico 9/15/2012 20:18'!
rentaFija: rentaActual
	rentaFija := rentaActual.! !

!EmpresaConRentaFija methodsFor: 'as yet unclassified' stamp: 'Federico 9/15/2012 20:17'!
rentaPara: jugador
	^self rentaFija.! !

!Propiedad methodsFor: 'getter' stamp: 'Federico 9/18/2012 10:44'!
cayo: jugador
	(self dueo ~= jugador) ifTrue: [self dueo teVisito: jugador en: self.].! !

!Propiedad methodsFor: 'getter' stamp: 'Federico 9/3/2012 19:08'!
dueo
	^dueo.! !

!Propiedad methodsFor: 'setter' stamp: 'Federico 9/3/2012 19:08'!
dueo: nuevoDueo
	dueo := nuevoDueo.! !

!Propiedad methodsFor: 'setter' stamp: 'Federico 10/9/2012 14:46'!
hipotecate
	self precio: self precio * 1,5.
	self dueo: self tablero banco .
	! !

!Propiedad methodsFor: 'getter' stamp: 'Federico 9/3/2012 19:09'!
precio
	^precio.! !

!Propiedad methodsFor: 'setter' stamp: 'Federico 9/3/2012 19:09'!
precio: nuevoPrecio
	precio := nuevoPrecio.! !

!Propiedad methodsFor: 'setter' stamp: 'Federico 9/17/2012 19:09'!
sosEmpresa
	^false.! !

Casillero subclass: #Salida
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Salida methodsFor: 'as yet unclassified' stamp: 'Federico 9/11/2012 21:56'!
paso: unJugador
	unJugador recibe: 5000.! !

Object subclass: #Garca
	instanceVariableNames: 'campos tablero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Garca methodsFor: 'as yet unclassified' stamp: 'Federico 10/3/2012 17:10'!
queresQue: unJugador Compre: unaPropiedad
	| propiedades |
	unaPropiedad sosEmpresa 
		ifTrue: 
			[ propiedades := unaPropiedad tablero empresas  .] 
		ifFalse: 
			[ propiedades := unaPropiedad provincia propiedades .].
		^propiedades anySatisfy: [:propiedad | (propiedad dueo ~= unaPropiedad dueo) | (propiedad dueo ~= unJugador) .].! !

Object subclass: #Imperialista
	instanceVariableNames: 'campos tablero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Imperialista methodsFor: 'as yet unclassified' stamp: 'Federico 10/3/2012 17:18'!
queresQue: unJugador Compre: unaPropiedad
	| propiedades  |
	unaPropiedad sosEmpresa 
		ifTrue: 
			[ ^unaPropiedad tablero empresas allSatisfy: [:propiedad | propiedad dueo = unaPropiedad dueo .] .] 
		ifFalse: 
			[ propiedades := unaPropiedad provincia propiedades .
			^ (propiedades anySatisfy: [:propiedad | propiedad dueo = unJugador .]) | (propiedades allSatisfy: [:propiedad | propiedad dueo = unaPropiedad dueo .]) .]! !

Object subclass: #Juego
	instanceVariableNames: 'jugadores tablero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Juego methodsFor: 'as yet unclassified' stamp: 'Federico 9/8/2012 10:57'!
agregarJugadores: jugadorNuevo
	jugadores add: jugadorNuevo.
	jugadorNuevo posicionEnTablero: self tablero casilleros first.  "Pone el jugador nuevo en la salida (primer casillero del tablero)"! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Federico 10/3/2012 16:12'!
casillerosPara: unJugador con: numeroDado
	^self tablero casillerosDesde: unJugador posicionEnTablero hasta: numeroDado. ! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Federico 9/11/2012 05:20'!
initialize
	jugadores := OrderedCollection new.! !

!Juego methodsFor: 'getter' stamp: 'Federico 9/3/2012 20:55'!
jugadores
	^jugadores.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Federico 10/3/2012 18:29'!
queJuegue: unJugador
	|numeroDado  casilleros |
	numeroDado := unJugador tirarDados.
	[unJugador estado jugo: unJugador saco: numeroDado .] on: EstasEnBancarrotaError do: [:e | self jugadores remove: unJugador .].	
	self queJuegueElQueSigue.! !

!Juego methodsFor: 'as yet unclassified' stamp: 'Federico 9/3/2012 19:20'!
queJuegueElQueSigue
	| elQueSigue |
	elQueSigue := self jugadores add: self jugadores removeFirst.
	self queJuegue: elQueSigue.! !

!Juego methodsFor: 'getter' stamp: 'Federico 9/6/2012 22:16'!
tablero
	^tablero.! !

!Juego methodsFor: 'setter' stamp: 'Federico 9/6/2012 22:16'!
tablero: tableroActual
	tablero := tableroActual.! !

Object subclass: #Jugador
	instanceVariableNames: 'propiedades tablero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

Jugador subclass: #Banco
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Banco methodsFor: 'as yet unclassified' stamp: 'Federico 9/8/2012 10:50'!
recibe: unDinero 
	"El banco no recibe plata ya que su dinero es infinito"! !

!Banco methodsFor: 'as yet unclassified' stamp: 'Federico 10/3/2012 16:56'!
teVisito: jugador en: propiedad
	( jugador estrategia queresQue: jugador Compre: propiedad ) ifTrue: [ jugador comprar: propiedad .].! !

!Jugador methodsFor: 'accessing' stamp: 'Federico 9/17/2012 21:43'!
agregarPropiedades: nuevaPropiedad
	propiedades add: nuevaPropiedad.
	nuevaPropiedad dueo: self.! !

!Jugador methodsFor: 'accessing' stamp: 'Federico 9/17/2012 21:43'!
initialize
	propiedades := OrderedCollection new.! !

!Jugador methodsFor: 'getter' stamp: 'Federico 9/17/2012 21:43'!
propiedades 
	^propiedades.! !

!Jugador methodsFor: 'getter' stamp: 'Federico 10/3/2012 16:22'!
tablero
	^tablero! !

!Jugador methodsFor: 'setter' stamp: 'Federico 10/3/2012 16:22'!
tablero: tableroActual
	tablero := tableroActual.! !

Jugador subclass: #Participante
	instanceVariableNames: 'dinero posicionEnTablero cantidadDeDoble cantidadTurnosPreso estado estrategia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Participante methodsFor: 'accessing' stamp: 'Federico 9/17/2012 21:16'!
avanzarPor: casilleros 
	casilleros do: [ : unCasillero | unCasillero paso: self].! !

!Participante methodsFor: 'accessing' stamp: 'Federico 9/17/2012 21:18'!
caerEn: casillero
	casillero cayo: self.
	self posicionEnTablero: casillero.! !

!Participante methodsFor: 'accessing' stamp: 'Federico 9/22/2012 05:35'!
cantidadEmpresas
	^self propiedades count: [:propiedad | propiedad sosEmpresa. ].! !

!Participante methodsFor: 'getter' stamp: 'Federico 10/3/2012 16:30'!
cantidadTurnosPreso
	^cantidadTurnosPreso! !

!Participante methodsFor: 'setter' stamp: 'Federico 10/3/2012 16:31'!
cantidadTurnosPreso: cantidadPresoActual
	cantidadTurnosPreso := cantidadPresoActual.! !

!Participante methodsFor: 'setter' stamp: 'Federico 10/3/2012 16:16'!
casillerosPara: numeroDado
	^self tablero casillerosDesde: self posicionEnTablero hasta: numeroDado. ! !

!Participante methodsFor: 'accessing' stamp: 'Federico 9/17/2012 21:09'!
comprar: propiedad
	self pagar: propiedad precio.
	self agregarPropiedades: propiedad.! !

!Participante methodsFor: 'accessing' stamp: 'Federico 9/17/2012 21:10'!
comprarEstanciaEn: campo
	self pagar: campo costoConstruccionEstancia . ! !

!Participante methodsFor: 'getter' stamp: 'Federico 9/3/2012 19:11'!
dinero
	^dinero.! !

!Participante methodsFor: 'setter' stamp: 'Federico 9/3/2012 19:11'!
dinero: dineroActual
	dinero := dineroActual.! !

!Participante methodsFor: 'getter' stamp: 'Federico 10/3/2012 16:32'!
estado
	^estado! !

!Participante methodsFor: 'setter' stamp: 'Federico 10/3/2012 16:32'!
estado: estadoActual
	estado := estadoActual .! !

!Participante methodsFor: 'getter' stamp: 'Federico 10/3/2012 16:43'!
estrategia
	^estrategia! !

!Participante methodsFor: 'setter' stamp: 'Federico 10/3/2012 16:43'!
estrategia: estrategiaActual
	estrategia := estrategiaActual! !

!Participante methodsFor: 'accessing' stamp: 'Federico 10/3/2012 18:13'!
hipotecaAlgunaPropiedad

	| propiedadAHipotecar |
	propiedadAHipotecar := self propiedades anyOne.
	self recibe: propiedadAHipotecar precio / 2. 
	propiedadAHipotecar sosEmpresa ifFalse: [self recibe: propiedadAHipotecar cantidadEstancias * propiedadAHipotecar costoConstruccionEstancia].
	propiedadAHipotecar hipotecate.
	
	
	! !

!Participante methodsFor: 'accessing' stamp: 'Federico 9/18/2012 10:46'!
moveteUnos: casilleros
	self avanzarPor: casilleros.
	self caerEn: casilleros last.! !

!Participante methodsFor: 'accessing' stamp: 'Federico 9/18/2012 10:41'!
paga: plata a: otroJugador 
	(self ~= otroJugador) 
		ifTrue: [self pagar: plata.
				otroJugador recibe: plata.].! !

!Participante methodsFor: 'accessing' stamp: 'Federico 9/17/2012 21:03'!
pagar: plata
	self verificaPosiblePago: plata.
	self dinero: self dinero - plata. ! !

!Participante methodsFor: 'accessing' stamp: 'Federico 10/3/2012 16:34'!
poneteLibre 
	self estado: Libre new.
	self cantidadDeDoble: 0,
	self cantidadTurnosPreso: 0.! !

!Participante methodsFor: 'accessing' stamp: 'Federico 10/3/2012 16:34'!
ponetePreso 
	self estado: Preso new.
	self cantidadDeDoble: 0.! !

!Participante methodsFor: 'getter' stamp: 'Apo 9/6/2012 17:00'!
posicionEnTablero
	^posicionEnTablero.! !

!Participante methodsFor: 'setter' stamp: 'Apo 9/6/2012 17:01'!
posicionEnTablero: posicionActual
	posicionEnTablero := posicionActual.! !

!Participante methodsFor: 'accessing' stamp: 'Apo 9/6/2012 15:42'!
recibe: unDinero 
	self dinero: self dinero + unDinero.! !

!Participante methodsFor: 'accessing' stamp: 'Federico 10/3/2012 16:10'!
sacasteDoble 
	self cantidadDeDoble: self cantidadDeDoble + 1.! !

!Participante methodsFor: 'accessing' stamp: 'Federico 9/15/2012 20:13'!
teVisito: jugador en: propiedad
	| renta |
	renta := propiedad rentaPara: jugador.
	jugador pagar: renta. 
	self recibe: renta.! !

!Participante methodsFor: 'accessing' stamp: 'Federico 10/3/2012 18:02'!
tenesQueHipotecarPara: plataAPagar 
	
	self verificaPosibleHipoteca.
	self hipotecaAlgunaPropiedad.
	self dinero >= plataAPagar ifFalse: [self tenesQueHipotecarPara: plataAPagar]! !

!Participante methodsFor: 'accessing' stamp: 'Federico 10/3/2012 16:06'!
tirarDado
	^(1to: 6) atRandom.! !

!Participante methodsFor: 'accessing' stamp: 'Federico 10/3/2012 16:08'!
tirarDados
	| dado1 dado2 |
	dado1 := self tirarDado.
	dado2 := self tirarDado.
	dado1 = dado2 ifTrue: [self sacasteDoble. ] ifFalse: [self cantidadDeDoble: 0. ] .
	^dado1+ dado2.! !

!Participante methodsFor: 'accessing' stamp: 'Federico 10/3/2012 18:29'!
verificaPosibleHipoteca

	self propiedades size > 0
		ifFalse: 
			[ EstasEnBancarrotaError signal .].! !

!Participante methodsFor: 'accessing' stamp: 'Federico 10/3/2012 17:56'!
verificaPosiblePago: plata
	self dinero >= plata ifFalse: [self tenesQueHipotecarPara: plata]! !

Object subclass: #Libre
	instanceVariableNames: 'campos tablero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Libre methodsFor: 'as yet unclassified' stamp: 'Federico 10/3/2012 16:18'!
jugo: unJugador saco: numeroDado
	unJugador cantidadDeDoble = 2 ifTrue: [ unJugador ponetePreso .] ifFalse: [ unJugador moveteUnos: (unJugador casillerosPara: numeroDado) .]. ! !

Object subclass: #Preso
	instanceVariableNames: 'campos tablero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Preso methodsFor: 'as yet unclassified' stamp: 'Federico 10/3/2012 16:28'!
jugo: unJugador saco: numeroDado
	(unJugador cantidadDeDoble = 1) | (unJugador cantidadTurnosPreso = 3) 
		ifTrue: 
			[ unJugador poneteLibre .  
			  unJugador moveteUnos: (unJugador casillerosPara: numeroDado) .] 
		ifFalse: 
			[ unJugador cantidadTurnosPreso: unJugador cantidadTurnosPreso + 1 .].! !

Object subclass: #Provincia
	instanceVariableNames: 'campos tablero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Provincia methodsFor: 'as yet unclassified' stamp: 'Federico 9/6/2012 22:09'!
agregarCampos: nuevoCampo
	campos add: nuevoCampo.! !

!Provincia methodsFor: 'getter' stamp: 'Federico 9/3/2012 21:17'!
campos
	^campos.! !

!Provincia methodsFor: 'as yet unclassified' stamp: 'Federico 9/4/2012 01:59'!
construccionParejaEn: campo
	^campos allSatisfy: [:unCampo | campo cantidadEstancias <= unCampo cantidadEstancias. ].! !

!Provincia methodsFor: 'as yet unclassified' stamp: 'Federico 9/6/2012 22:07'!
dueos
	^(campos collect: [:unCampo | unCampo dueo. ]) asSet.! !

!Provincia methodsFor: 'as yet unclassified' stamp: 'Federico 9/17/2012 21:25'!
esProvinciaMonopolica
	| dueo |
	dueo := campos first dueo.
	^campos allSatisfy: [:campo | campo dueo = dueo].! !

!Provincia methodsFor: 'as yet unclassified' stamp: 'Federico 9/6/2012 22:05'!
initialize 
	campos := OrderedCollection new.
	 ! !

!Provincia methodsFor: 'setter' stamp: 'Federico 9/17/2012 21:24'!
sePuedeConstruirEn: campo
	self verificaConstruccionEn: campo.
	^true.! !

!Provincia methodsFor: 'getter' stamp: 'Federico 9/3/2012 21:46'!
tablero
	^tablero.! !

!Provincia methodsFor: 'setter' stamp: 'Federico 9/6/2012 22:24'!
tablero: tableroActual
	tablero := tableroActual.
	tableroActual agregarProvincias: self.! !

!Provincia methodsFor: 'setter' stamp: 'Federico 9/17/2012 21:25'!
verificaConstruccionEn: campo
	(self esProvinciaMonopolica and: [ self construccionParejaEn: campo. ]) ifFalse: [self error: 'no se puede construir' .].! !

Object subclass: #Standard
	instanceVariableNames: 'campos tablero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Standard methodsFor: 'as yet unclassified' stamp: 'Federico 10/3/2012 16:55'!
queresQue: unJugador Compre: propiedad
	^true.! !

Object subclass: #Tablero
	instanceVariableNames: 'banco casilleros provincias'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!

!Tablero methodsFor: 'as yet unclassified' stamp: 'Federico 9/6/2012 22:10'!
agregarCasilleros: casilleroNuevo
	casilleros add: casilleroNuevo.! !

!Tablero methodsFor: 'as yet unclassified' stamp: 'Federico 9/6/2012 22:10'!
agregarProvincias: nuevaProvincia
	provincias add: nuevaProvincia.! !

!Tablero methodsFor: 'getter' stamp: 'Federico 9/3/2012 21:08'!
banco
	^banco.! !

!Tablero methodsFor: 'setter' stamp: 'Federico 9/6/2012 08:33'!
banco: bancoActual
	banco := bancoActual.
	bancoActual tablero: self.! !

!Tablero methodsFor: 'getter' stamp: 'Federico 9/3/2012 21:11'!
casilleros
	^casilleros.! !

!Tablero methodsFor: 'as yet unclassified' stamp: 'Apo 9/6/2012 17:27'!
casillerosDesde: casilleroInicial hasta: unNumero
	| misCasilleros recorrido |
	misCasilleros := self casilleros copyAfter: casilleroInicial.
	recorrido := OrderedCollection new.
	[ recorrido size >= unNumero ] whileFalse: [
	misCasilleros ifEmpty: [
	misCasilleros addAll: self casilleros.
	].
	recorrido add: misCasilleros removeFirst. ].

	^recorrido.! !

!Tablero methodsFor: 'as yet unclassified' stamp: 'Federico 9/11/2012 05:20'!
initialize
	casilleros := OrderedCollection new.
	provincias := OrderedCollection new.! !

!Tablero methodsFor: 'getter' stamp: 'Federico 9/3/2012 21:48'!
provincias
	^provincias! !

Error subclass: #EstasEnBancarrotaError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero'!
